#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <process.h>
#include <stdio.h>
#include "CRmtDlg.h"

#include "..\resource.h"

//萔̒`
#define LV_COLUMN_REMOCON_CH 0
#define LV_COLUMN_TVBRODCAST 1


//////////////////////////////////////////////////////////////////////////////
//RXgN^/fRXgN^
CRmtDlg::CRmtDlg(){
	ZeroMemory(&m_lChRemote[0],sizeof(m_lChRemote));
	m_cDbTVInfo.Init();
}

CRmtDlg::~CRmtDlg(){
	m_cDbTVInfo.UnInit();
}

//////////////////////////////////////////////////////////////////////////////
//o֐
BOOL CRmtDlg::put_Channel(int nIdx, long lIdx){
	if(nIdx < 0 || nIdx > 11)return FALSE;

	m_lChRemote[nIdx] = lIdx;

	return TRUE;
}

BOOL CRmtDlg::get_Channel(int nIdx, long *plIdx){
	if(nIdx < 0 || nIdx > 11)return FALSE;

	*plIdx = m_lChRemote[nIdx];

	return TRUE;
}

//NOTIFYnh
void CRmtDlg::OnNmDbClk_ListBroadCast(LPARAM lP){
	LPNMITEMACTIVATE lpnmitem;
	lpnmitem = (LPNMITEMACTIVATE)lP;

	switch(lpnmitem->iSubItem){
	case LV_COLUMN_TVBRODCAST:
		{
			if(lpnmitem->iItem >= 0 && lpnmitem->iItem < 12){
				int i;
				int nCount;
				ST_TV_INFOMATION stInfo;

				m_ListView.ComboBoxColum(lpnmitem->iItem,lpnmitem->iSubItem);
				
				nCount = 0;
				m_cDbTVInfo.GetCount(&nCount);

				m_ListView.ComboBoxInsertItem(-1,"ݒ薳");
				for(i=0;i<nCount;++i){
					m_cDbTVInfo.GetInfoIdx(i,&stInfo,sizeof(ST_TV_INFOMATION));
					m_ListView.ComboBoxInsertItem(-1,stInfo.szSvrName);
				}
				LVITEM lvitem;
				ZeroMemory(&lvitem,sizeof(lvitem));
				lvitem.mask = LVIF_PARAM;
				lvitem.iItem = lpnmitem->iItem;
				m_ListView.GetItem(&lvitem);
				m_ListView.ComboBoxSetCurSel(lvitem.lParam+1);
			}
		}
		break;
	}
}

//R}hnh
void CRmtDlg::OnOK(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){

	int i;
	LVITEM lvitem;
	ZeroMemory(&lvitem,sizeof(lvitem));
	lvitem.mask = LVIF_PARAM;
	for(i=0;i<12;++i){
		lvitem.iItem = i;
		m_ListView.GetItem(&lvitem);
		m_lChRemote[i] = lvitem.lParam;
	}

	m_ListView.ReSetSubClassListView();
}

void CRmtDlg::OnCancel(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	m_ListView.ReSetSubClassListView();
}


//bZ[Wnh
int CRmtDlg::OnWmInitDlg(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	DWORD dwExStyle;
	int iIdx;
	int i;
	char szText[128];
	ST_TV_INFOMATION stInfo;

	//EChȄ擾
	m_hWnd = hDlg;
	m_hInst = (HINSTANCE)GetWindowLong(hDlg,GWL_HINSTANCE);

	//^uݒ肷
	m_ListView.m_hWnd = GetDlgItem(hDlg,IDC_LIST_REMOCON);
	m_ListView.m_hWParent = m_hWnd;
	m_ListView.SetSubClassListView();

	m_ListView.InsertColumn(60,	LV_COLUMN_REMOCON_CH,		"Rԍ");
	m_ListView.InsertColumn(180,	LV_COLUMN_TVBRODCAST,		"ǖ");

	//X^Cݒ肷
	dwExStyle = m_ListView.GetExtendedListViewStyle();
	dwExStyle = dwExStyle|LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES;
	m_ListView.SetExtendedListViewStyle(dwExStyle);

	//Xgݒ肷
	for(i=0;i<12;++i){
		//Rԍ}(1`12)
		sprintf(szText,"%d",i+1);

		//ڂ֑}
		iIdx = m_ListView.InsertItem(szText,m_ListView.GetItemCount());
	}

	//R̐ݒ
	LVITEM lvitem;
	ZeroMemory(&lvitem,sizeof(lvitem));
	lvitem.mask = LVIF_PARAM;

	for(i=0;i<12;++i){
		lvitem.iItem = i;
		lvitem.lParam = (LPARAM)m_lChRemote[i];
		
		m_ListView.SetItem(&lvitem);
		if(m_lChRemote[i] == -1){
			m_ListView.SetItemText("ݒ薳",i,1);
		}
		else{
			m_cDbTVInfo.GetInfoIdx(m_lChRemote[i],&stInfo,sizeof(ST_TV_INFOMATION));

			//ACȅԂݒ肷
			m_ListView.SetItemText(stInfo.szSvrName,i,1);
		}
	}

	return 0;
}

int CRmtDlg::OnWmNotify(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	int idCtrl = wP;
	LPNMHDR pnmh = (LPNMHDR)lP;

	switch(idCtrl){
	case IDC_LIST_REMOCON:
		switch(pnmh->code){
		case NM_DBLCLK:
			OnNmDbClk_ListBroadCast(lP);
			break;
		}

		break;
	}

	return 0;
}

int CRmtDlg::OnWmCommand(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){

	switch(GET_WM_COMMAND_ID(wP,lP)){
	case IDOK:
		OnOK(hDlg,msg,wP,lP);
		break;

	case IDCANCEL:
		OnCancel(hDlg,msg,wP,lP);
		break;
	}

	return 0;
}

//bZ[Wv-W[
LRESULT CRmtDlg::DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){

	switch (uMsg){
	case WM_COMMAND:
		return OnWmCommand(hWnd,uMsg,wParam,lParam);

	case WM_INITDIALOG:
		return OnWmInitDlg(hWnd,uMsg,wParam,lParam);

	case WM_DESTROY:
		break;

	case WM_NOTIFY:
		return OnWmNotify(hWnd,uMsg,wParam,lParam);
		break;
	}

	return 0;
}
