#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <Shlobj.h>
#include "CVidSnapShotDlg.h"
#include "..\ComCtrl\BrowsFolder.h"
#include "..\Setting\Csetting.h"
#include "..\resource.h"

CVidSnapShotDlg::CVidSnapShotDlg(){
	m_szCapFileName[0] = '\0';				//^t@C(pX)
	m_iSnapShotFmt = PTDIGI_SNAP_FMT_JPG;	//L^`
	m_iJpegQuality = 80;					//JPEGL^i
	m_nSnapSize = 0;
}

CVidSnapShotDlg::~CVidSnapShotDlg(){
}

//R}hnh
void CVidSnapShotDlg::OnOK(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	
	//pX擾
	GetDlgItemText(hDlg,IDC_EDIT_FILE,&m_szCapFileName[0],MAX_PATH);

	//`擾
	if(SendDlgItemMessage(hDlg,IDC_RADIO_BMP,BM_GETCHECK,0,0) == BST_CHECKED)
		m_iSnapShotFmt = PTDIGI_SNAP_FMT_BMP;
	else
		m_iSnapShotFmt = PTDIGI_SNAP_FMT_JPG;

	//i擾
	m_iJpegQuality = GetDlgItemInt(hDlg,IDC_EDIT_JPEG_QUALITY,NULL,FALSE);
	if(m_iJpegQuality < 0)m_iJpegQuality = 0;
	if(m_iJpegQuality > 100) m_iJpegQuality = 100;

	//IĂCfbNX擾
	m_nSnapSize = SendDlgItemMessage(hDlg,IDC_COMBO_SNAP_SIZE,CB_GETCURSEL,0,0);
	if(m_nSnapSize == CB_ERR){
		m_nSnapSize = 0;
	}
}

void CVidSnapShotDlg::OnCancel(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
}

void CVidSnapShotDlg::OnRadioBmp(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_JPEG_QUALITY),FALSE);
}

void CVidSnapShotDlg::OnRadioJpeg(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_JPEG_QUALITY),TRUE);
}

void CVidSnapShotDlg::OnBtnFile(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	BROWSEINFO pbi;
	LPITEMIDLIST lpid;
	int lRet = FALSE;

	char default_path[MAX_PATH];
	char get_path[MAX_PATH];
		
	ZeroMemory(&pbi,sizeof(BROWSEINFO));

	/*݂̃pX擾*/
	GetDlgItemText(hDlg,IDC_EDIT_FILE,&default_path[0],MAX_PATH);
		
	pbi.hwndOwner=m_hWnd;
	pbi.pidlRoot = NULL;/*c[̃[gƂȂNameSpaceݒ肷 NULL:fXNgbv*/
	pbi.pszDisplayName = get_path;/*IꂽtH_͂|C^*/
	pbi.lpszTitle = "ۑ̑I";/*_CAÕ^Cg*/
	//pbi.ulFlags;       /*Rg[ԂU镑w肷tO*/
	pbi.lpfn = &BrowseCallbackProc;/*R[obN֐̎w*/
	pbi.lParam = (LPARAM)default_path;/*pXw肷*/
	lpid = SHBrowseForFolder(&pbi);

	if(lpid){
		lRet = SHGetPathFromIDList(lpid,get_path);
		CoTaskMemFree(lpid);
	}

	if(lRet == TRUE){
		SetDlgItemText(hDlg,IDC_EDIT_FILE,get_path);
	}
}

//bZ[Wnh
int CVidSnapShotDlg::OnWmInitDlg(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	m_hWnd = hDlg;
	m_hInst = (HINSTANCE)GetWindowLong(hDlg,GWL_HINSTANCE);

	//ݒ肷
	
	//ۑtH_ݒ肷
	SetDlgItemText(hDlg,IDC_EDIT_FILE,m_szCapFileName);

	//TCYݒ肷
	SendDlgItemMessage(hDlg,IDC_COMBO_SNAP_SIZE,CB_INSERTSTRING,-1,(LPARAM)"100%");
	SendDlgItemMessage(hDlg,IDC_COMBO_SNAP_SIZE,CB_INSERTSTRING,-1,(LPARAM)"25%");
	SendDlgItemMessage(hDlg,IDC_COMBO_SNAP_SIZE,CB_INSERTSTRING,-1,(LPARAM)"50%");
	SendDlgItemMessage(hDlg,IDC_COMBO_SNAP_SIZE,CB_INSERTSTRING,-1,(LPARAM)"75%");
	SendDlgItemMessage(hDlg,IDC_COMBO_SNAP_SIZE,CB_INSERTSTRING,-1,(LPARAM)"125%");

	//ڂI
	SendDlgItemMessage(hDlg,IDC_COMBO_SNAP_SIZE,CB_SETCURSEL,m_nSnapSize,NULL);

	//^`ݒ肷
	switch(m_iSnapShotFmt){
	case PTDIGI_SNAP_FMT_JPG:
	default:
		SendDlgItemMessage(hDlg,IDC_RADIO_BMP,BM_SETCHECK,0,0);
		SendDlgItemMessage(hDlg,IDC_RADIO_JPEG,BM_SETCHECK,1,0);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_JPEG_QUALITY),TRUE);
		break;
	case PTDIGI_SNAP_FMT_BMP:
		SendDlgItemMessage(hDlg,IDC_RADIO_BMP,BM_SETCHECK,1,0);
		SendDlgItemMessage(hDlg,IDC_RADIO_JPEG,BM_SETCHECK,0,0);
		EnableWindow(GetDlgItem(hDlg,IDC_EDIT_JPEG_QUALITY),FALSE);
		break;
	}

	
	//JPEG̕iݒ肷
	SendDlgItemMessage(hDlg,IDC_SPIN_JPEG_QUALITY,UDM_SETRANGE,0,MAKELONG(100, 0)); 
	SetDlgItemInt(hDlg,IDC_EDIT_JPEG_QUALITY,m_iJpegQuality,FALSE);
	
	return 0;
}

int CVidSnapShotDlg::OnWmCommand(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	switch(GET_WM_COMMAND_ID(wP,lP)){

	case IDOK:
		OnOK(hDlg,msg,wP,lP);
		break;

	case IDCANCEL:
		break;

	case IDC_RADIO_BMP:
		OnRadioBmp(hDlg,msg,wP,lP);
		break;

	case IDC_RADIO_JPEG:
		OnRadioJpeg(hDlg,msg,wP,lP);
		break;

	case IDC_BTN_FILE:
		OnBtnFile(hDlg,msg,wP,lP);
		break;
	}

	return 0;
}

//bZ[Wv-W[
LRESULT CVidSnapShotDlg::DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){

	switch (uMsg){
	case WM_COMMAND:
		return OnWmCommand(hWnd,uMsg,wParam,lParam);

	case WM_INITDIALOG:
		return OnWmInitDlg(hWnd,uMsg,wParam,lParam);

	case WM_DESTROY:
		break;
	}

	return 0;
}
