#include <windows.h>
#include "CSetting.h"

#define APP_REG_FOLDER_APP "Software\\PetitTV\\AppCfg"
#define APP_REG_FOLDER_CAP "Software\\PetitTV\\CapCfg"
#define APP_REG_FOLDER_REC "Software\\PetitTV\\RecCfg"

CSetting::CSetting(void){
	int i;

	m_nAppStatus = 0;

	//ʐݒ
	m_lAudioVolume = 50;
	m_IsMute = FALSE;
	m_lTVAudio = 0;

	//ʕ\ݒ
	m_IsTopMost = FALSE;
	m_IsPlayer = TRUE;

	//XLݒ
	m_szSkinFile[0] = '\0';

	//^ݒ
	m_szCapDirName[0] = '\0';

	//hCoݒ
	m_szDriverFile[0] = '\0';
	
	//Î~Lv`ݒ
	m_iSnapShotFmt = 1;					//Î~Lv`摜`(0:BMP 1:JPEG)
	m_iJpegQuality = 75;					//JPEGki
	m_szSnapDirName[0] = '\0';
	m_nSnapSize = 0;

	//erݒ
	m_lChannel = 0;						//`lԍ(1`113,`lԍŕێ)
	for(i=0;i<12;++i)
		m_lRemCh[i] = -1;
}

CSetting::~CSetting(void){
}

BOOL CSetting::Load(void){
	int lRet;
	HKEY hKey;
	DWORD dwType;
	DWORD cbData;
	DWORD dwBuf;//ǂݍ݃obt@
	BYTE szBuf[MAX_PATH];//ǂݍ݃obt@

	//////////////////////////////////////////////////////////////////////////
	//WXg̃L[I[v(AvP[Vݒ)
	lRet = RegOpenKeyEx(HKEY_CURRENT_USER,APP_REG_FOLDER_APP,0,KEY_READ,&hKey);
	if(lRet != ERROR_SUCCESS) return FALSE;

	dwType = REG_DWORD;	cbData = sizeof(DWORD);
	lRet = RegQueryValueEx(hKey,"IsTopMost",NULL,&dwType,(BYTE *)&dwBuf,&cbData);
	if(lRet == ERROR_SUCCESS) m_IsTopMost = dwBuf;

	dwType = REG_DWORD;	cbData = sizeof(DWORD);
	lRet = RegQueryValueEx(hKey,"IsPlayer",NULL,&dwType,(BYTE *)&dwBuf,&cbData);
	if(lRet == ERROR_SUCCESS) m_IsPlayer = dwBuf;

	dwType = REG_DWORD;	cbData = sizeof(DWORD);
	lRet = RegQueryValueEx(hKey,"lAudioVolume",NULL,&dwType,(BYTE *)&dwBuf,&cbData);
	if(lRet == ERROR_SUCCESS) m_lAudioVolume = dwBuf;
	
	dwType = REG_DWORD;	cbData = sizeof(DWORD);
	lRet = RegQueryValueEx(hKey,"IsMute",NULL,&dwType,(BYTE *)&dwBuf,&cbData);
	if(lRet == ERROR_SUCCESS) m_IsMute = dwBuf;

	dwType = REG_DWORD;	cbData = sizeof(DWORD);
	lRet = RegQueryValueEx(hKey,"TVAudio",NULL,&dwType,(BYTE *)&dwBuf,&cbData);
	if(lRet == ERROR_SUCCESS) m_lTVAudio = dwBuf;

	dwType = REG_SZ; cbData = sizeof(szBuf);szBuf[0] = '\0';
	lRet = RegQueryValueEx(hKey,"SkinFile",NULL,&dwType,(BYTE *)&szBuf[0],&cbData);
	if(lRet == ERROR_SUCCESS){strcpy(m_szSkinFile,(char *)&szBuf[0]);}

	dwType = REG_BINARY;	cbData = sizeof(m_lRemCh);
	lRet = RegQueryValueEx(hKey,"RemoconIdx",NULL,&dwType,(BYTE *)&m_lRemCh[0],&cbData);
	if(lRet != ERROR_SUCCESS){
		ZeroMemory(&m_lRemCh[0],cbData);
	}

	//L[N[Y
	RegCloseKey(hKey);

	//////////////////////////////////////////////////////////////////////////
	//WXg̃L[I[v(foCXݒ)
	lRet = RegOpenKeyEx(HKEY_CURRENT_USER,APP_REG_FOLDER_CAP,0,KEY_READ,&hKey);
	if(lRet != ERROR_SUCCESS) return FALSE;

	dwType = REG_SZ; cbData = sizeof(szBuf);szBuf[0] = '\0';
	lRet = RegQueryValueEx(hKey,"DriverName",NULL,&dwType,(BYTE *)&szBuf[0],&cbData);
	if(lRet == ERROR_SUCCESS){strcpy(m_szDriverFile,(char *)&szBuf[0]);}

	dwType = REG_DWORD;	cbData = sizeof(DWORD);
	lRet = RegQueryValueEx(hKey,"Channel",NULL,&dwType,(BYTE *)&dwBuf,&cbData);
	if(lRet == ERROR_SUCCESS) m_lChannel = dwBuf;

	//L[N[Y
	RegCloseKey(hKey);

	//////////////////////////////////////////////////////////////////////////
	//WXg̃L[I[v(^ݒ)
	lRet = RegOpenKeyEx(HKEY_CURRENT_USER,APP_REG_FOLDER_REC,0,KEY_READ,&hKey);
	if(lRet != ERROR_SUCCESS) return FALSE;

	dwType = REG_SZ; cbData = sizeof(szBuf);szBuf[0] = '\0';
	lRet = RegQueryValueEx(hKey,"CapDirName",NULL,&dwType,(BYTE *)&szBuf[0],&cbData);
	if(lRet == ERROR_SUCCESS){strcpy(m_szCapDirName,(char *)&szBuf[0]);}

	dwType = REG_SZ; cbData = sizeof(szBuf);szBuf[0] = '\0';
	lRet = RegQueryValueEx(hKey,"SnapDirName",NULL,&dwType,(BYTE *)&szBuf[0],&cbData);
	if(lRet == ERROR_SUCCESS){strcpy(m_szSnapDirName,(char *)&szBuf[0]);}

	dwType = REG_DWORD;	cbData = sizeof(DWORD);
	lRet = RegQueryValueEx(hKey,"SnapShotFmt",NULL,&dwType,(BYTE *)&dwBuf,&cbData);
	if(lRet == ERROR_SUCCESS) m_iSnapShotFmt = dwBuf;

	dwType = REG_DWORD;	cbData = sizeof(DWORD);
	lRet = RegQueryValueEx(hKey,"JpegQuality",NULL,&dwType,(BYTE *)&dwBuf,&cbData);
	if(lRet == ERROR_SUCCESS) m_iJpegQuality = dwBuf;

	dwType = REG_DWORD;	cbData = sizeof(DWORD);
	lRet = RegQueryValueEx(hKey,"SnapSize",NULL,&dwType,(BYTE *)&dwBuf,&cbData);
	if(lRet == ERROR_SUCCESS) m_nSnapSize = dwBuf;

	//L[N[Y
	RegCloseKey(hKey);

	return TRUE;

}

BOOL CSetting::Save(void){
	int lRet;
	HKEY hKey;

	//////////////////////////////////////////////////////////////////////////
	//WXg̃L[쐬(AvP[Vݒ)
	lRet = RegOpenKeyEx(HKEY_CURRENT_USER,APP_REG_FOLDER_APP,0,KEY_WRITE,&hKey);
	if(lRet != ERROR_SUCCESS){
		lRet = RegCreateKeyEx(HKEY_CURRENT_USER,APP_REG_FOLDER_APP,0,NULL,0,KEY_ALL_ACCESS, NULL, &hKey, NULL);
		if(lRet != ERROR_SUCCESS){
			return FALSE;
		}
	}


	RegSetValueEx(hKey,"IsTopMost"		,0,REG_DWORD	,(CONST BYTE *)&m_IsTopMost			,sizeof(m_IsTopMost));
	RegSetValueEx(hKey,"IsPlayer"		,0,REG_DWORD	,(CONST BYTE *)&m_IsPlayer			,sizeof(m_IsPlayer));

	RegSetValueEx(hKey,"lAudioVolume"	,0,REG_DWORD	,(CONST BYTE *)&m_lAudioVolume		,sizeof(m_lAudioVolume));
	RegSetValueEx(hKey,"IsMute"			,0,REG_DWORD	,(CONST BYTE *)&m_IsMute			,sizeof(m_IsMute));
	RegSetValueEx(hKey,"TVAudio"		,0,REG_DWORD	,(CONST BYTE *)&m_lTVAudio			,sizeof(m_lTVAudio));

	RegSetValueEx(hKey,"SkinFile"		,0,REG_SZ	,(CONST BYTE *)&m_szSkinFile[0]			,strlen(m_szSkinFile));

	RegSetValueEx(hKey,"RemoconIdx"		,0,REG_BINARY	,(CONST BYTE *)&m_lRemCh[0]	,sizeof(m_lRemCh));

	//L[N[Y
	RegCloseKey(hKey);

	//////////////////////////////////////////////////////////////////////////
	//WXg̃L[쐬(^ݒ)
	lRet = RegOpenKeyEx(HKEY_CURRENT_USER,APP_REG_FOLDER_REC,0,KEY_WRITE,&hKey);
	if(lRet != ERROR_SUCCESS){
		lRet = RegCreateKeyEx(HKEY_CURRENT_USER,APP_REG_FOLDER_REC,0,NULL,0,KEY_ALL_ACCESS, NULL, &hKey, NULL);
		if(lRet != ERROR_SUCCESS){
			return FALSE;
		}
	}

	RegSetValueEx(hKey,"CapDirName"	,0,REG_SZ		,(CONST BYTE *)&m_szCapDirName[0]	,strlen(m_szCapDirName));

	RegSetValueEx(hKey,"SnapDirName"		,0,REG_SZ		,(CONST BYTE *)&m_szSnapDirName[0]		,strlen(m_szSnapDirName));
	RegSetValueEx(hKey,"JpegQuality"		,0,REG_DWORD	,(CONST BYTE *)&m_iJpegQuality			,sizeof(m_iJpegQuality));
	RegSetValueEx(hKey,"SnapShotFmt"		,0,REG_DWORD	,(CONST BYTE *)&m_iSnapShotFmt			,sizeof(m_iSnapShotFmt));
	RegSetValueEx(hKey,"SnapSize"			,0,REG_DWORD	,(CONST BYTE *)&m_nSnapSize				,sizeof(m_nSnapSize));

	//L[N[Y
	RegCloseKey(hKey);

	//////////////////////////////////////////////////////////////////////////
	//WXg̃L[쐬(vC}Lv`ݒ)
	lRet = RegOpenKeyEx(HKEY_CURRENT_USER,APP_REG_FOLDER_CAP,0,KEY_WRITE,&hKey);
	if(lRet != ERROR_SUCCESS){
		lRet = RegCreateKeyEx(HKEY_CURRENT_USER,APP_REG_FOLDER_CAP,0,NULL,0,KEY_ALL_ACCESS, NULL, &hKey, NULL);
		if(lRet != ERROR_SUCCESS){
			return FALSE;
		}
	}
	RegSetValueEx(hKey,"Channel"			,0,REG_DWORD	,(CONST BYTE *)&m_lChannel					,sizeof(m_lChannel));
	RegSetValueEx(hKey,"DriverName"			,0,REG_SZ		,(CONST BYTE *)&m_szDriverFile[0]		,strlen(m_szDriverFile));

	//L[N[Y
	RegCloseKey(hKey);

	return TRUE;
}

void CSetting::put_AppStatus(int nStatus){
	m_nAppStatus = nStatus;
}

int CSetting::get_AppStatus(void){
	return m_nAppStatus;
}

//ʂݒ肷
void CSetting::put_AudioVolume(long lVolume){
	m_lAudioVolume = lVolume;
}

//ʂ擾
long CSetting::get_AudioVolume(void){
	return m_lAudioVolume;
}

//~[gݒ肷
void CSetting::put_IsMute(BOOL mode){
	m_IsMute = mode;
}

//~[g擾
BOOL CSetting::get_IsMute(void){
	return m_IsMute;
}

//TV[hݒ肷
void CSetting::put_TVAudio(long lMode){
	m_lTVAudio = lMode;
}

//TV[h擾
long CSetting::get_TVAudio(void){
	return m_lTVAudio;
}

void CSetting::put_IsTopMost(BOOL IsMode){
	m_IsTopMost = IsMode;
}

BOOL CSetting::get_IsTopMost(void){
	return m_IsTopMost;
}

void CSetting::put_IsPlayer(BOOL IsMode){
	m_IsPlayer = IsMode;
}

BOOL CSetting::get_IsPlayer(void){
	return m_IsPlayer;
}


//Lv`t@Cݒ肷
void CSetting::put_CapDirName(char *pszName){
	if(pszName == NULL) return;
	strncpy(m_szCapDirName,pszName,MAX_PATH-1);
	m_szCapDirName[MAX_PATH-1] = '\0';
}

//Lv`t@C擾
void CSetting::get_CapDirName(char *pszName){
	if(pszName == NULL) return;
	strcpy(pszName,m_szCapDirName);
}

//
void CSetting::put_SnapShotFmt(int iFmt){
	m_iSnapShotFmt = iFmt;
}

//
int CSetting::get_SnapShotFmt(void){
	return m_iSnapShotFmt;
}

//Î~Lv`JPEGiݒ肷
void CSetting::put_JpegQuality(int iQuality){
	m_iJpegQuality = iQuality;
}

//Î~Lv`JPEGi擾
BOOL CSetting::get_JpegQuality(void){
	return m_iJpegQuality;
}

//Lv`t@Cݒ肷
void CSetting::put_SnapDirName(char *pszName){
	if(pszName == NULL) return;
	strcpy(m_szSnapDirName,pszName);
}

//Lv`t@C擾
void CSetting::get_SnapDirName(char *pszName){
	if(pszName == NULL) return;
	strcpy(pszName,m_szSnapDirName);
}

void CSetting::put_SnapSize(int nSize){
	m_nSnapSize = nSize;
}

int CSetting::get_SnapSize(void){
	return m_nSnapSize;
}

//`lԍݒ肷
void CSetting::put_Channel(long iChannel){
	m_lChannel = iChannel;
}

//`lԍ𓾂
long CSetting::get_Channel(void){
	return m_lChannel;
}

void CSetting::put_SkinFile(char *pszName){
	if(pszName == NULL) return;
	strcpy(m_szSkinFile,pszName);
}

void CSetting::get_SkinFile(char *pszName){
	if(pszName == NULL) return;
	strcpy(pszName,m_szSkinFile);
}

void CSetting::put_DriverFile(char *pszFile){
	if(pszFile == NULL) return;
	strcpy(m_szDriverFile,pszFile);
}

void CSetting::get_DriverFile(char *pszFile){
	if(pszFile == NULL) return;
	strcpy(pszFile,m_szDriverFile);
}


void CSetting::put_RemCh(int idx , long lCh){
	if(idx < 0 || idx > 11)return;
	m_lRemCh[idx] = lCh;
}

long CSetting::get_RemCh(int idx){
	if(idx < 0 || idx > 11)return 0;
	return m_lRemCh[idx];
}
