#ifndef _C_PLAYER_WINDOW_
#define _C_PLAYER_WINDOW_

#include "CBaseWnd.h"
#include "..\View\CViewPlayer.h"
#include "..\Setting\CSetting.h"

//XL萔
#define MINCTRL_SKIN_PATH ".\\Skin\\"

//^C}[ID
#define TIMERID_PLAYER_INFO 1

class CMiniCtrlWnd : public CBaseWnd{

public:
	CMiniCtrlWnd();
	~CMiniCtrlWnd();


	//o֐
	HWND CreateWnd(DWORD dwExStyle,DWORD dwStyle,
				int x,int y,int nWidth,int nHeight,
				HWND hwndParent,
				HMENU hmenu,
				HINSTANCE hinst);

	BOOL SaveWndPos(void);
	BOOL LoadWndPos(RECT *pRc);

	void put_cSetting(CSetting *pSetting);
	BOOL SetSkin(char *pszSkinFile);

	//O̕`֐(XL֘A)
	void DrawVolume(long lVolume);		//{[`悷
	void DrawButton(void);		//{^`悷
	void DrawPlayerStat(int nAppStat);	//vC[̏Ԃ`悷
	void DrawPlayerInfo(void);
	void DrawClock(int nTime);
	BOOL UpdateView(ST_CV_PLY_FUNC_PARAM *pParam);
	void SetPlayerInfo(char *pszInfo);
	BOOL IsSamePlayerInfo(char *pszInfo);

	void SetVolumeCallBack(LPPROC_AudioVolume pProc,LPVOID lParam);


	//R[obN
	LRESULT WndProck(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam);

private:

	CViewPlayer m_cViewPlayer;
	CSetting *m_pcSetting;

	int m_nTime;

	BOOL SetChannel(int nIdx);

	//^C}[R[obN
	void TimerProc_PlayerInfo(void);

	//R}hnh
	void OnClose(void);
	void OnCh01(void);
	void OnCh02(void);
	void OnCh03(void);
	void OnCh04(void);
	void OnCh05(void);
	void OnCh06(void);
	void OnCh07(void);
	void OnCh08(void);
	void OnCh09(void);
	void OnCh10(void);
	void OnCh11(void);
	void OnCh12(void);
	void OnCfg(void);
	void OnRec(void);
	void OnVolumeUp(void);
	void OnVolumeDown(void);
	void OnMute(void);
	void OnChannelUp(void);
	void OnChannelDown(void);
	void OnIEPG(void);
	void OnSnapShot(void);
	void OnStop(void);

	//bZ[Wnh
	LRESULT OnWmCreate(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWmClose(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWmPaint(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWmMouseMove(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWMLButtonDown(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWMLButtonUp(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWMLButtonDbclk(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWmRButtonDown(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWmDestroy(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWmCommand(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);
	LRESULT OnWmTimer(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam);

};

#endif
